package com.tanpu.feo.feojob.service;

import com.tanpu.common.constant.BizStatus;
import com.tanpu.feo.feojob.dao.personaluser.entity.*;
import com.tanpu.feo.feojob.dao.personaluser.mapper.PersonalCurriculumResMapper;
import com.tanpu.feo.feojob.dao.personaluser.mapper.PersonalTagCategoryMapper;
import com.tanpu.feo.feojob.dao.personaluser.mapper.PersonalTagMapper;
import com.tanpu.feo.feojob.dao.personaluser.mapper.PersonalTagRelMapper;
import com.tanpu.feo.feojob.dao.user.entity.CurriculumRes;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

/**
 * 个人版
 */
@Service
public class PersonalService {

    @Resource
    private PersonalCurriculumResMapper personalCurriculumResMapper;

    @Resource
    private PersonalTagRelMapper personalTagRelMapper;

    @Resource
    private PersonalTagMapper personalTagMapper;

    @Resource
    private PersonalTagCategoryMapper personalTagCategoryMapper;


    /**
     * CURRICULUM_RES
     */
    public List<PersonalCurriculumRes> selectAllShortVideosByCreateTime(Date createTime) {
        PersonalCurriculumResExample example = new PersonalCurriculumResExample();
        example.createCriteria().andAudioTypeEqualTo(3).andCreateTimeGreaterThanOrEqualTo(createTime).andDeleteTagEqualTo(BizStatus.DeleteTag.tag_init);
        return personalCurriculumResMapper.selectByExample(example);
    }

    /**
     * TAG
     */
    public List<PersonalTag> selectTagByIds(List<String> ids) {
        PersonalTagExample example = new PersonalTagExample();
        example.createCriteria().andIdIn(ids).andDeleteTagEqualTo(BizStatus.DeleteTag.tag_init);

        return personalTagMapper.selectByExample(example);
    }

    /**
     * TAG_REL
     */
    public List<PersonalTagRel> selectTagRelByResIds(List<String> relIds) {
        PersonalTagRelExample example = new PersonalTagRelExample();
        example.createCriteria().andRelIdIn(relIds);

        return personalTagRelMapper.selectByExample(example);
    }

    /**
     * CATEGORY
     */
    public List<PersonalTagCategory> selectCategoryByIds(List<String> ids) {
        PersonalTagCategoryExample example = new PersonalTagCategoryExample();
        example.createCriteria().andIdIn(ids).andDeleteTagEqualTo(BizStatus.DeleteTag.tag_init);

        return personalTagCategoryMapper.selectByExample(example);
    }
}
